function love.load()
	love.graphics.setFont(12)
	love.keyboard.setKeyRepeat(10,1000)
	dx, dy = 0, 0

	--map
	map={
{1,4,1,4,1,4,1,4,1,4,3,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4,4}, --only half is used
{4,1,4,1,4,1,4,1,4,1,4,3,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4},
{1,4,1,4,1,4,1,4,1,4,1,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4,4},
{4,2,4,2,4,2,4,2,4,1,4,1,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,5,4,1,4,1,4,3,4,3,4,3,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,5,4,1,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,5,4,1,4,3,4,3,4,3,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,5,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,5,4,3,4,3,4,3,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,3,4,3,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4}
	}

	--map variables
	map_w = #map[1] -- obtenir la largeur de la map
	map_h = #map --pareil pour la hauteur
	map_x = 0 --region à centrer
    map_y = 0
    map_display_w = 40 --region à dessiner
	map_display_h = 20
	tile_w = 32
	tile_h = 32
	tile_w_disp = 16 --apparent tile size
	tile_h_disp = 24
	
	-- tiles
	--player_tileset = love.graphics.newImage("Player.png")
	world_tileset = love.graphics.newImage("tileset.png")
	tile = {}
	tileset_w = 480 --largeur totale de la tileset
	tileset_h = 480 --hauteur totale de la tileset
	tileset_y = 0 --ligne de la tilseset a parcourir
	tileset_x = 0 --colonne
	i=1 --each quad has a number
	for tileset_y = 0, tileset_h / tile_h -1 do --define quads
		for tileset_x = 0, tileset_w / tile_w -1 do
			tile[i] = love.graphics.newQuad(tileset_x * tile_w, tileset_y * tile_h, tile_w, tile_h, tileset_w, tileset_h)
			i = i + 1
		end
	end
end
	
function draw_map()
	for y=1, map_display_h do
		for x=1, map_display_w do
			if math.fmod(x+y, 2) == 0 and x+map_x < map_w and y+map_y < map_h and x+map_x > 0 and y+map_y > 0 then
				love.graphics.drawq(
				world_tileset,
				tile[map[y+map_y][x+map_x]],	-- on ouvre l'enmplacement du tableau "tile"
				( (x-dx) *tile_w_disp)-tile_w_disp-dx,		-- pour l'affichage on donne le nb de px, (x-dx) : smooth movement
				( (y-dy) *tile_h_disp)-tile_h_disp-dy)		-- pareil
			end
		end
    end
end

function love.draw()
	draw_map()
end

function move_map()
	if dx == 0  and dy == 0 then
		if love.keyboard.isDown("left") then
			map_x = map_x - 2
			dx, dy = 2, 0
		end
		if love.keyboard.isDown("right") then
			map_x = map_x + 2
			dx, dy = -2, 0
		end
		if love.keyboard.isDown('down') then 
			if love.keyboard.isDown('right') then
				--map_x = map_x + 1
				map_x = map_x - 1
				map_y = map_y + 1
				dx, dy = -1, -1
			elseif love.keyboard.isDown('left') then
				--map_x = map_x - 1
				map_x = map_x + 1
				map_y = map_y + 1
				dx, dy = 1, -1
			end
		end
		if love.keyboard.isDown('up') then
			if love.keyboard.isDown('right') then
				--map_x = map_x + 1
				map_x = map_x - 1
				map_y = map_y - 1
				dx, dy = -1, 1
			elseif love.keyboard.isDown('left') then
				--map_x = map_x - 1
				map_x = map_x + 1
				map_y = map_y - 1
				dx, dy = 1, 1
			end	
		end
	end
end

function love.keypressed(key, unicode)
	if love.keyboard then
		if key == 'escape' then
			love.event.push('q') -- quit the game
		end
	end
end

function love.update(dt)
	move_map()
	local v -- thanks linux-man :}
	if dy == 0 then v = 2 else v = 1 end -- when jumping on x only player must move 2x faster.
	if dx > 0 then dx = dx - dt * v
	elseif dx < 0 then dx = dx + dt * v
	end
	if dy > 0 then dy = dy - dt
	elseif dy < 0 then dy = dy + dt
	end
	if math.abs(dx) < dt * v then dx = 0 end
	if math.abs(dy) < dt then dy = 0 end
end
